/**
 * Grammar of ALLL plan name.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
grammar PlanNameGrammar;

@header {
    package gdefalll.Grammars;
    import java.util.ArrayList;
}

@lexer::header{
	package gdefalll.Grammars;
	import java.util.ArrayList;
}

@members {
    private int error_starting_position = -1;
    private ArrayList<String> errors = new ArrayList<String>();
    public void displayRecognitionError(String[] tokenNames,
                                        RecognitionException e)
    {
        String hdr = getErrorHeader(e);
        String msg = getErrorMessage(e, tokenNames);
        errors.add(hdr + " " + msg);
        if (error_starting_position < 0)
        {
	  error_starting_position = e.charPositionInLine;
        }
    }
    public int getErrorStartingPosition()
    {
      return error_starting_position;
    }
    public ArrayList<String> getErrors()
    {
        return errors;
    }
}

parse
    :    plan_name EOF
    ;

// tupple

plan_name
	:	WORD
	;
	


// Words, which include our operators
WORD
	:	('a'..'z' | 'A'..'Z') ('a'..'z' | 'A'..'Z' | '0'..'9' | '_')*
	;