package gdefalll.events;

import java.util.ArrayList;
import java.util.Iterator;

public class ActionChangedGenerator {
	private ArrayList<ActionChangedListener> _listeners = new ArrayList<ActionChangedListener>();
    
    public synchronized void addListener( ActionChangedListener l ) {
        _listeners.add( l );
    }
    
    public synchronized void removeListener( ActionChangedListener l ) {
        _listeners.remove( l );
    }
     
    public synchronized void fireActionChanged() {
        Iterator<ActionChangedListener> listeners = _listeners.iterator();
        while( listeners.hasNext() ) {
            ( (ActionChangedListener) listeners.next() ).actionChanged();
        }
    }
}
