package gdefalll.events;

import java.util.ArrayList;
import java.util.Iterator;

public class OkCancelGenerator {
	private ArrayList<OkCancelListener> _listeners = new ArrayList<OkCancelListener>();
    
    public synchronized void addListener( OkCancelListener l ) {
        _listeners.add( l );
    }
    
    public synchronized void removeListener( OkCancelListener l ) {
        _listeners.remove( l );
    }
     
    public synchronized void fireOk() {
        Iterator<OkCancelListener> listeners = _listeners.iterator();
        while( listeners.hasNext() ) {
            ( (OkCancelListener) listeners.next() ).handleOkEvent();
        }
    }
    
    public synchronized void fireCancel() {
        Iterator<OkCancelListener> listeners = _listeners.iterator();
        while( listeners.hasNext() ) {
            ( (OkCancelListener) listeners.next() ).handleCancelEvent();
        }
    }
}
