package gdefalll.events;

import java.util.ArrayList;
import java.util.Iterator;

public class StatusChangeGenerator {
	    private ArrayList<StatusChangeListener> _listeners = new ArrayList<StatusChangeListener>();
	    
	    public synchronized void addListener( StatusChangeListener l ) {
	        _listeners.add( l );
	    }
	    
	    public synchronized void removeListener( StatusChangeListener l ) {
	        _listeners.remove( l );
	    }
	     
	    public synchronized void fire(String text) {
	    	StatusChangeEvent event = new StatusChangeEvent( this, new StatusMessage(text) );
	        Iterator<StatusChangeListener> listeners = _listeners.iterator();
	        while( listeners.hasNext() ) {
	            ( (StatusChangeListener) listeners.next() ).statusReceived( event );
	        }
	    }
}
