package gdefalll.events;

import java.util.ArrayList;
import java.util.Iterator;

public class StringContentGenerator {
	private ArrayList<StringContentListener> _listeners = new ArrayList<StringContentListener>();
    
    public synchronized void addListener( StringContentListener l ) {
        _listeners.add( l );
    }
    
    public synchronized void removeListener( StringContentListener l ) {
        _listeners.remove( l );
    }
     
    public synchronized void fire(String text) {
        Iterator<StringContentListener> listeners = _listeners.iterator();
        while( listeners.hasNext() ) {
            ( (StringContentListener) listeners.next() ).stringContentReceived( text );
        }
    }
}
