package gdefalll.gui;

import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JTextField;
import java.awt.Dimension;
import javax.swing.JTextArea;
import javax.swing.border.LineBorder;
import java.awt.Color;
import javax.swing.UIManager;
import java.awt.Font;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JSeparator;

import gdefalll.events.PlanChangedListener;
import gdefalll.events.StatusChangeEvent;
import gdefalll.events.StatusChangeGenerator;
import gdefalll.events.StatusChangeListener;
import gdefalll.gui.GuiPlanEditor;
import gdefalll.gui.highlighters.ALLLBBHighlighter;

import javax.swing.JFileChooser;
import javax.swing.JRadioButton;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.BoxLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.io.*;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * Agent editor panel. It is the main component of each agent (Each in separated tab).
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class GuiAgentEditor extends JPanel implements StatusChangeListener, PlanChangedListener{

	private static final long serialVersionUID = 0L;
	private ALLLBBHighlighter R1;
	private ALLLBBHighlighter R2;
	private ALLLBBHighlighter R3;
	private JTextField Plan;
	final JPanel ActionSelector = new JPanel();
	final GuiPlanEditor plan_viewer = new GuiPlanEditor();
	final JRadioButton rdbtnAdd = new JRadioButton("Add");
	final JRadioButton rdbtnDel = new JRadioButton("Del");
	final JRadioButton rdbtnCheckBB = new JRadioButton("Check BB");
	final JRadioButton rdbtnCheckIB = new JRadioButton("Check IB");
	final JRadioButton rdbtnTime = new JRadioButton("Time");
	final JRadioButton rdbtnForMessage = new JRadioButton("For message");
	final JRadioButton rdbtnMessageNotice = new JRadioButton("Message notice");
	final JRadioButton rdbtnLeds = new JRadioButton("LEDs");
	final JRadioButton rdbtnMessage = new JRadioButton("Message");
	final JRadioButton rdbtnSubplan = new JRadioButton("Subplan");
	final JRadioButton rdbtnRemotePlan = new JRadioButton("Remote plan");
	final JRadioButton rdbtnCatchSection = new JRadioButton("Catch section");
	final ButtonGroup bgroup = new ButtonGroup();
	JTextArea PB = new JTextArea();
	private String agent_name = "New agent";
	final JFileChooser fc = new JFileChooser();
	
	
	
	
	public StatusChangeGenerator status = new StatusChangeGenerator();
	
	/**
	 * Create the panel.
	 */
	public GuiAgentEditor() {
		setLayout(new BorderLayout(0, 0));
		
		JPanel EditorFrame = new JPanel();
		add(EditorFrame, BorderLayout.CENTER);
		EditorFrame.setLayout(new BorderLayout(0, 0));
		
		JPanel Editor = new JPanel();
		Editor.setLayout(new BorderLayout(0, 0));
		
		Editor.add(plan_viewer.getScrollPane());
		EditorFrame.add(Editor, BorderLayout.CENTER);
		
		
		Editor.add(ActionSelector, BorderLayout.WEST);
		ActionSelector.setLayout(new BoxLayout(ActionSelector, BoxLayout.Y_AXIS));
		
		JLabel lblBeliefBase = new JLabel("Belief Base");
		ActionSelector.add(lblBeliefBase);
		
		setButtonsListeners(rdbtnAdd, GuiPlanEditor.Mode.ADD_BB);
		setButtonsListeners(rdbtnDel, GuiPlanEditor.Mode.DEL_BB);
		setButtonsListeners(rdbtnCheckBB, GuiPlanEditor.Mode.CHECK_BB);
		setButtonsListeners(rdbtnCheckIB, GuiPlanEditor.Mode.CHECK_IB);
		setButtonsListeners(rdbtnTime, GuiPlanEditor.Mode.WAIT_TIME);
		setButtonsListeners(rdbtnForMessage, GuiPlanEditor.Mode.WAIT_MSG);
		setButtonsListeners(rdbtnMessageNotice, GuiPlanEditor.Mode.WAIT_MSG_START);
		setButtonsListeners(rdbtnLeds, GuiPlanEditor.Mode.LEDS);
		setButtonsListeners(rdbtnMessage, GuiPlanEditor.Mode.MESSAGE);
		setButtonsListeners(rdbtnSubplan, GuiPlanEditor.Mode.SUBPLAN);
		setButtonsListeners(rdbtnRemotePlan, GuiPlanEditor.Mode.REMOTE_PLAN);
		setButtonsListeners(rdbtnCatchSection, GuiPlanEditor.Mode.CATCH_SECTION);

		
		
		rdbtnAdd.setIcon(MyIcons.getIcon(MyIcons.Type.ADD_BB));
		ActionSelector.add(rdbtnAdd);
		
		rdbtnDel.setIcon(MyIcons.getIcon(MyIcons.Type.DEL_BB));
		ActionSelector.add(rdbtnDel);		
		
		rdbtnCheckBB.setIcon(MyIcons.getIcon(MyIcons.Type.CHECK_BB));
		ActionSelector.add(rdbtnCheckBB);
		
		JSeparator separator_3 = new JSeparator();
		ActionSelector.add(separator_3);
		
		JLabel lblInputBase = new JLabel("Input Base");
		ActionSelector.add(lblInputBase);
		
		rdbtnCheckIB.setIcon(MyIcons.getIcon(MyIcons.Type.CHECK_IB));
		ActionSelector.add(rdbtnCheckIB);
		
		JSeparator separator_1 = new JSeparator();
		ActionSelector.add(separator_1);
		
		JLabel lblWait = new JLabel("Wait");
		ActionSelector.add(lblWait);
		
		
		rdbtnTime.setIcon(MyIcons.getIcon(MyIcons.Type.WAIT_TIME));
		ActionSelector.add(rdbtnTime);
		
		
		rdbtnForMessage.setIcon(MyIcons.getIcon(MyIcons.Type.WAIT_MSG));
		ActionSelector.add(rdbtnForMessage);
		
		rdbtnMessageNotice.setIcon(MyIcons.getIcon(MyIcons.Type.WAIT_MSG_START));
		ActionSelector.add(rdbtnMessageNotice);
		
		JSeparator separator_2 = new JSeparator();
		ActionSelector.add(separator_2);
		
		JLabel lblOutput = new JLabel("Output");
		ActionSelector.add(lblOutput);
		
		
		rdbtnLeds.setIcon(MyIcons.getIcon(MyIcons.Type.LEDS));
		ActionSelector.add(rdbtnLeds);
		
		
		rdbtnMessage.setIcon(MyIcons.getIcon(MyIcons.Type.MESSAGE));
		ActionSelector.add(rdbtnMessage);
		
		JSeparator separator_4 = new JSeparator();
		ActionSelector.add(separator_4);
		
		JLabel lblRunSubplan = new JLabel("Run plan");
		ActionSelector.add(lblRunSubplan);
		
		
		rdbtnSubplan.setIcon(MyIcons.getIcon(MyIcons.Type.SUBPLAN));
		ActionSelector.add(rdbtnSubplan);
		
		
		rdbtnRemotePlan.setIcon(MyIcons.getIcon(MyIcons.Type.REMOTE_PLAN));
		ActionSelector.add(rdbtnRemotePlan);
		
		JSeparator separator_5 = new JSeparator();
		ActionSelector.add(separator_5);
		
		
		rdbtnCatchSection.setIcon(MyIcons.getIcon(MyIcons.Type.CATCH_SECTION));
		ActionSelector.add(rdbtnCatchSection);
		
		
		JSeparator separator = new JSeparator();
		EditorFrame.add(separator, BorderLayout.SOUTH);
		
		JPanel Inspector = new JPanel();
		Inspector.setBorder(new LineBorder(new Color(0, 0, 0)));
		add(Inspector, BorderLayout.SOUTH);
		Inspector.setLayout(new BorderLayout(0, 0));
		
		JPanel panel = new JPanel();
		Inspector.add(panel, BorderLayout.WEST);
		
		JPanel StatePanel = new JPanel();
		StatePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		panel.add(StatePanel);
		StatePanel.setPreferredSize(new Dimension(200, 150));
		StatePanel.setMinimumSize(new Dimension(200, 10));
		GridBagLayout gbl_StatePanel = new GridBagLayout();
		gbl_StatePanel.columnWidths = new int[]{7, 0, 0};
		gbl_StatePanel.rowHeights = new int[]{5, 15, 0, 0, 0, 0, 0};
		gbl_StatePanel.columnWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		gbl_StatePanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		StatePanel.setLayout(gbl_StatePanel);
		
		JLabel lblReg = new JLabel("Reg2");
		lblReg.setFont(new Font("Dialog", Font.PLAIN, 12));
		GridBagConstraints gbc_lblReg = new GridBagConstraints();
		gbc_lblReg.insets = new Insets(0, 0, 5, 5);
		gbc_lblReg.anchor = GridBagConstraints.NORTHWEST;
		gbc_lblReg.gridx = 0;
		gbc_lblReg.gridy = 2;
		StatePanel.add(lblReg, gbc_lblReg);
		
		JLabel lblNewLabel = new JLabel("Reg1");
		lblNewLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel.anchor = GridBagConstraints.NORTHWEST;
		gbc_lblNewLabel.gridx = 0;
		gbc_lblNewLabel.gridy = 1;
		StatePanel.add(lblNewLabel, gbc_lblNewLabel);
		
		R2 = new ALLLBBHighlighter(ALLLBBHighlighter.Mode.SIMPLE);
		R2.setMinimumSize(new Dimension(100, 19));
		R2.setPreferredSize(new Dimension(100, 19));
		R2.setSize(new Dimension(100, 19));
		GridBagConstraints gbc_R2 = new GridBagConstraints();
		gbc_R2.fill = GridBagConstraints.BOTH;
		gbc_R2.insets = new Insets(0, 0, 5, 0);
		gbc_R2.gridx = 1;
		gbc_R2.gridy = 2;
		StatePanel.add(R2, gbc_R2);
		//R2.setColumns(10);
		
		JLabel lblReg_1 = new JLabel("Reg3");
		lblReg_1.setFont(new Font("Dialog", Font.PLAIN, 12));
		GridBagConstraints gbc_lblReg_1 = new GridBagConstraints();
		gbc_lblReg_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblReg_1.anchor = GridBagConstraints.SOUTHWEST;
		gbc_lblReg_1.gridx = 0;
		gbc_lblReg_1.gridy = 3;
		StatePanel.add(lblReg_1, gbc_lblReg_1);
		
		R1 = new ALLLBBHighlighter(ALLLBBHighlighter.Mode.SIMPLE);
		R1.setMinimumSize(new Dimension(100, 19));
		R1.setSize(new Dimension(100, 19));
		R1.setPreferredSize(new Dimension(100, 19));
		GridBagConstraints gbc_R1 = new GridBagConstraints();
		gbc_R1.fill = GridBagConstraints.BOTH;
		gbc_R1.insets = new Insets(0, 0, 5, 0);
		gbc_R1.gridx = 1;
		gbc_R1.gridy = 1;
		StatePanel.add(R1, gbc_R1);
		//R1.setColumns(10);
		
		R3 = new ALLLBBHighlighter(ALLLBBHighlighter.Mode.SIMPLE);
		R3.setSize(new Dimension(100, 19));
		R3.setPreferredSize(new Dimension(100, 19));
		R3.setMinimumSize(new Dimension(100, 19));
		GridBagConstraints gbc_R3 = new GridBagConstraints();
		gbc_R3.fill = GridBagConstraints.BOTH;
		gbc_R3.insets = new Insets(0, 0, 5, 0);
		gbc_R3.gridx = 1;
		gbc_R3.gridy = 3;
		StatePanel.add(R3, gbc_R3);
		//R3.setColumns(10);
		
		JLabel lblAgentId = new JLabel("Agent ID");
		GridBagConstraints gbc_lblAgentId = new GridBagConstraints();
		gbc_lblAgentId.anchor = GridBagConstraints.WEST;
		gbc_lblAgentId.insets = new Insets(0, 0, 5, 5);
		gbc_lblAgentId.gridx = 0;
		gbc_lblAgentId.gridy = 4;
		StatePanel.add(lblAgentId, gbc_lblAgentId);
		
		JSpinner AgID = new JSpinner();
		AgID.setModel(new SpinnerNumberModel(1, 1, 65535, 1));
		AgID.setPreferredSize(new Dimension(100, 20));
		GridBagConstraints gbc_AgID = new GridBagConstraints();
		gbc_AgID.anchor = GridBagConstraints.EAST;
		gbc_AgID.insets = new Insets(0, 0, 5, 0);
		gbc_AgID.gridx = 1;
		gbc_AgID.gridy = 4;
		StatePanel.add(AgID, gbc_AgID);
		
		JLabel lblClassId = new JLabel("Class ID");
		GridBagConstraints gbc_lblClassId = new GridBagConstraints();
		gbc_lblClassId.anchor = GridBagConstraints.WEST;
		gbc_lblClassId.insets = new Insets(0, 0, 0, 5);
		gbc_lblClassId.gridx = 0;
		gbc_lblClassId.gridy = 5;
		StatePanel.add(lblClassId, gbc_lblClassId);
		
		JSpinner ClassID = new JSpinner();
		ClassID.setModel(new SpinnerNumberModel(1, 1, 65535, 1));
		ClassID.setPreferredSize(new Dimension(100, 20));
		GridBagConstraints gbc_ClassID = new GridBagConstraints();
		gbc_ClassID.anchor = GridBagConstraints.EAST;
		gbc_ClassID.gridx = 1;
		gbc_ClassID.gridy = 5;
		StatePanel.add(ClassID, gbc_ClassID);
		
		JPanel InputBase = new JPanel();
		panel.add(InputBase);
		GridBagLayout gbl_InputBase = new GridBagLayout();
		gbl_InputBase.columnWidths = new int[]{150, 0};
		gbl_InputBase.rowHeights = new int[]{15, 80, 0};
		gbl_InputBase.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_InputBase.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		InputBase.setLayout(gbl_InputBase);
		
		JLabel lblInputbase = new JLabel("InputBase");
		lblInputbase.setFont(new Font("Dialog", Font.PLAIN, 12));
		lblInputbase.setBounds(0, 0, 153, 15);
		GridBagConstraints gbc_lblInputbase = new GridBagConstraints();
		gbc_lblInputbase.anchor = GridBagConstraints.NORTH;
		gbc_lblInputbase.fill = GridBagConstraints.HORIZONTAL;
		gbc_lblInputbase.insets = new Insets(0, 0, 5, 0);
		gbc_lblInputbase.gridx = 0;
		gbc_lblInputbase.gridy = 0;
		InputBase.add(lblInputbase, gbc_lblInputbase);
		
		JTextArea IB = new JTextArea();
		IB.setEditable(false);
		IB.setBorder(UIManager.getBorder("TextArea.border"));
		IB.setWrapStyleWord(true);
		IB.setPreferredSize(new Dimension(150, 150));
		IB.setBounds(0, 20, 153, 30);
		GridBagConstraints gbc_IB = new GridBagConstraints();
		gbc_IB.insets = new Insets(1, 0, 0, 0);
		gbc_IB.anchor = GridBagConstraints.NORTHWEST;
		gbc_IB.gridx = 0;
		gbc_IB.gridy = 1;
		InputBase.add(IB, gbc_IB);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(null);
		Inspector.add(panel_1, BorderLayout.CENTER);
		GridBagLayout gbl_panel_1 = new GridBagLayout();
		gbl_panel_1.columnWidths = new int[]{124, 0};
		gbl_panel_1.rowHeights = new int[]{0, 0, 0, 0, 0};
		gbl_panel_1.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panel_1.rowWeights = new double[]{0.0, 1.0, 0.0, 0.0, Double.MIN_VALUE};
		panel_1.setLayout(gbl_panel_1);
		
		JLabel lblPlanBase = new JLabel("Plan Base");
		lblPlanBase.setFont(new Font("Dialog", Font.PLAIN, 12));
		GridBagConstraints gbc_lblPlanBase = new GridBagConstraints();
		gbc_lblPlanBase.insets = new Insets(5, 0, 4, 0);
		gbc_lblPlanBase.gridx = 0;
		gbc_lblPlanBase.gridy = 0;
		panel_1.add(lblPlanBase, gbc_lblPlanBase);
		PB.setEditable(false);
		
		PB.setPreferredSize(new Dimension(0, 100));
		GridBagConstraints gbc_PB = new GridBagConstraints();
		gbc_PB.insets = new Insets(2, 0, 3, 0);
		gbc_PB.fill = GridBagConstraints.BOTH;
		gbc_PB.gridx = 0;
		gbc_PB.gridy = 1;
		panel_1.add(PB, gbc_PB);
		
		JLabel lblPlan = new JLabel("Plan");
		lblPlan.setFont(new Font("Dialog", Font.PLAIN, 12));
		GridBagConstraints gbc_lblPlan = new GridBagConstraints();
		gbc_lblPlan.insets = new Insets(0, 0, 3, 0);
		gbc_lblPlan.gridx = 0;
		gbc_lblPlan.gridy = 2;
		panel_1.add(lblPlan, gbc_lblPlan);
		
		Plan = new JTextField();
		Plan.setEditable(false);
		GridBagConstraints gbc_Plan = new GridBagConstraints();
		gbc_Plan.fill = GridBagConstraints.HORIZONTAL;
		gbc_Plan.gridx = 0;
		gbc_Plan.gridy = 3;
		panel_1.add(Plan, gbc_Plan);
		plan_viewer.status.addListener(this);
		GroupLayout gl_plan_viewer = new GroupLayout(plan_viewer);
		gl_plan_viewer.setHorizontalGroup(
			gl_plan_viewer.createParallelGroup(Alignment.LEADING)
				.addGap(0, 4000, Short.MAX_VALUE)
		);
		gl_plan_viewer.setVerticalGroup(
			gl_plan_viewer.createParallelGroup(Alignment.LEADING)
				.addGap(0, 3000, Short.MAX_VALUE)
		);
		plan_viewer.setLayout(gl_plan_viewer);
		plan_viewer.planChanged.addListener(this);
		Plan.setColumns(10);
	}
	
	/**
	 * Initialize radiobuttons that select the mode of plan editor. (which type of action should be added)
	 * @param btn
	 * @param mode
	 */
	private void setButtonsListeners(final JRadioButton btn, final GuiPlanEditor.Mode mode)
	{
		bgroup.add(btn);
		btn.setSelectedIcon(new ImageIcon(GuiAgentEditor.class.getResource("/gdefalll/Resources/icons/brick_add.png")));
		btn.setFocusPainted(false);
		btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (plan_viewer.getMode() != mode)
				{
					plan_viewer.setMode(mode);
				}
				else
				{
					plan_viewer.setMode(GuiPlanEditor.Mode.VIEW);
					bgroup.clearSelection();
				}
			}
		});
		btn.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if (btn.isSelected())
				{
					btn.setBackground(Color.ORANGE);
				}
				else
				{
					btn.setBackground(ActionSelector.getBackground());
				}
			}
		});
	}

	/* (non-Javadoc)
	 * Distribute the event (message to be shown in statusbar)
	 * @see gdefalll.events.StatusChangeListener#statusReceived(gdefalll.events.StatusChangeEvent)
	 */
	@Override
	public void statusReceived(StatusChangeEvent event) {
		status.fire(event.statusmessage().toString());
	}

	/* (non-Javadoc)
	 * Handle the event when plan is changed. Shows code in text fields.
	 * @see gdefalll.events.PlanChangedListener#planChanged()
	 */
	@Override
	public void planChanged() {
		bgroup.clearSelection();
		PB.setText(plan_viewer.getPlanBase());
		Plan.setText(plan_viewer.getIntention());
	}
	
	/**
	 * Set the name of agent.
	 * @param name
	 */
	public void setAgentName(String name)
	{
		this.agent_name = name;
	}
	
	/**
	 * @return Name of agent.
	 */
	public String getAgentName()
	{
		return this.agent_name;
	}
	
	/**
	 * Save agent.
	 * It open Save dialog and then call SaveXML(File file, GuiPlanEditor planEditor)
	 * @see SaveXML(File file, GuiPlanEditor planEditor)
	 */
	public void save()
	{
		int returnVal = fc.showSaveDialog(this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            SaveXML(file, plan_viewer);
        } else {
            //TODO: Error handling
        }
	}
	
	/**
	 * Write agent to the file as a XML structure.
	 * @param file
	 * @param planEditor
	 */
	private void SaveXML(File file, GuiPlanEditor planEditor)
	{
		try {
			ArrayList<GuiPlan> planList = planEditor.getPlanList();
			Iterator<GuiPlan> pi = planList.iterator();
			GuiPlan plan;
			FileWriter fstream = new FileWriter(file);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			out.write("<Agent>");
			
			if (pi.hasNext()) {
				out.write("<Intention>");
				plan = pi.next();
				out.write("<Name>");
				out.write(plan.getName());
				out.write("</Name>");
				out.write("<Position>");
				out.write("<X>");
				out.write(new Integer(plan.getX()).toString());
				out.write("</X>");
				out.write("<Y>");
				out.write(new Integer(plan.getY()).toString());
				out.write("</Y>");
				out.write("</Position>");
				out.write("<Code>");
				out.write(plan.getPlanCode());
				out.write("</Code>");
				out.write("</Intention>");
			}
			
			out.write("<PlanBase>");
			while (pi.hasNext()) {
				out.write("<Plan>");
				plan = pi.next();				
				out.write("<Name>");
				out.write(plan.getName());
				out.write("</Name>");				
				out.write("<Position>");
				out.write("<X>");
				out.write(new Integer(plan.getX()).toString());
				out.write("</X>");
				out.write("<Y>");
				out.write(new Integer(plan.getY()).toString());
				out.write("</Y>");
				out.write("</Position>");
				out.write("<Code>");
				out.write(plan.getPlanCode());
				out.write("</Code>");
				out.write("</Plan>");
			}
			out.write("</PlanBase>");
			
			out.write("</Agent>");
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	/**
	 * Load new agent.
	 */
	public void open()
	{
		int returnVal = fc.showOpenDialog(this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
           LoadXML(file, plan_viewer);
        } else {
            //TODO: Error handling
        }
	}

	/**
	 * Parse XML file to get agent structure. Intention and plan is set with using GuiPlan.setCode().
	 * @param file
	 * @param plan_viewer
	 * @see GuiPlan.setCode()
	 */
	private void LoadXML(File file, GuiPlanEditor plan_viewer) {
		try
		{
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.parse(file);
			doc.getDocumentElement().normalize();	 
			Element root = doc.getDocumentElement();
			Element intention = (Element) root.getElementsByTagName("Intention").item(0);			
			String intention_code = intention.getElementsByTagName("Code").item(0).getChildNodes().item(0).getNodeValue();
			String intention_name = intention.getElementsByTagName("Name").item(0).getChildNodes().item(0).getNodeValue();
			String intention_x = intention.getElementsByTagName("X").item(0).getChildNodes().item(0).getNodeValue();
			String intention_y = intention.getElementsByTagName("Y").item(0).getChildNodes().item(0).getNodeValue();
			GuiPlan plan = new GuiPlan(intention_name, new Integer(intention_x), new Integer(intention_y));
			plan.setCode(intention_code, plan_viewer);
			plan_viewer.addPlan(plan);
			
			Element planBase = (Element) root.getElementsByTagName("PlanBase").item(0);
			NodeList planList = planBase.getElementsByTagName("Plan");
			
			for (int temp = 0; temp < planList.getLength(); temp++) {
				Node nNode = planList.item(temp);
				if (nNode.getNodeType() == Node.ELEMENT_NODE) {
					Element planElement = (Element) nNode;
					String plan_code = planElement.getElementsByTagName("Code").item(0).getChildNodes().item(0).getNodeValue();
					String plan_name = planElement.getElementsByTagName("Name").item(0).getChildNodes().item(0).getNodeValue();
					String plan_x = planElement.getElementsByTagName("X").item(0).getChildNodes().item(0).getNodeValue();
					String plan_y = planElement.getElementsByTagName("Y").item(0).getChildNodes().item(0).getNodeValue();
					plan = new GuiPlan(plan_name, new Integer(plan_x), new Integer(plan_y));
					plan.setCode(plan_code, plan_viewer);
					plan_viewer.addPlan(plan);
				}
			}
			
			plan_viewer.repaint();
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
}
