package gdefalll.gui;

import java.awt.Point;

import javax.swing.JPanel;

/**
 * Basic class of dragable object.
 * It overrides getX, setX methods to be able to store current position and implements moveX function.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public abstract class GuiDragable extends JPanel {
	private static final long serialVersionUID = 0L;
	
	private int x;
	private int y;
	
	public void moveX(int delta){
		setX(x += delta);
	}
	
	public void moveY(int delta){
		setY(y += delta);
	}
	
	
	@Override
	public int getX(){
		return x;
	}
	
	@Override
	public int getY(){
		return y;
	}
	
	public void setX(int x){
		this.x = (x > 0) ? x : 0;
	}
	
	public void setY(int y){
		this.y = (y > 0) ? y : 0;
	}	
	
	public void setPosition(Point p){
		x = p.x;
		y = p.y;
	}
}
