package gdefalll.gui.actions;

import gdefalll.events.StringContentListener;
import gdefalll.gui.MyIcons;
import gdefalll.gui.highlighters.ALLLBBHighlighter;
import gdefalll.gui.dialogs.BBEditor;

import java.awt.Color;
import java.awt.Point;

import javax.swing.ImageIcon;
import javax.swing.SwingUtilities;

/**
 * Add to BB action.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class AddBB extends ALLLAction implements StringContentListener{
	
	private static final long serialVersionUID = 1L;
	ALLLBBHighlighter value_label = new ALLLBBHighlighter(ALLLBBHighlighter.Mode.SIMPLE);

	public AddBB() {
		super();		
		value_label.setBackground(this.getBackground());
		value_label.setBounds(getWidth()-130, 0, 130, getHeight());
		value_label.setText("(111)");
		add(value_label);
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.ADD_BB);
	}

	@Override
	public String getIdentifier() {
		return "+";
	}

	@Override
	String getLabelText() {
		return "Add to BB";
	}

	@Override
	Color getLabelColor() {
		return new Color(0, 128, 0);
	}

	@Override
	public void showEditor() {
		Point position = new Point(getLocation()); 
		SwingUtilities.convertPointToScreen(position, this);
		BBEditor editor = new BBEditor("Add to BB", ALLLBBHighlighter.Mode.SIMPLE);
		position.x = position.x - editor.getWidth() / 2 + this.getWidth() / 2;
		position.y = position.y - editor.getHeight() / 2 + this.getHeight() / 2;
		editor.setLocation(position);
		editor.setText(value_label.getText());
		editor.sg.addListener(this);
		editor.setVisible(true);
	}

	@Override
	public String getALLLCode() {
		return getIdentifier() + value_label.getText();
	}

	@Override
	public void stringContentReceived(String text) {
		value_label.setText(text);
		this.ACG.fireActionChanged();
	}

	@Override
	public void setParameters(String params) {
		stringContentReceived(params);
	}

}
