package gdefalll.gui.actions;

/**
 * Abstract class for InternalPlanEnd and InternalPlanStart.
 * Those two actions has to be linked together.
 * When one of them is deleted, we should delete nested action also.
 * @see InternalPlanStart
 * @see InternalPlanEnd
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public abstract class InternalPlan extends ALLLAction{
	/**
	 * Nested action. They should be a pair.
	 */
	ALLLAction nestedAction;
	private static final long serialVersionUID = 0L;
	
	/**
	 * Set nested action to pair with.
	 * @param nestedAction
	 */
	public void setNestedAction(ALLLAction nestedAction)
	{
		this.nestedAction = nestedAction;
	}
	
	/**
	 * Get nested action.
	 * @return
	 */
	public ALLLAction getNestedAction()
	{
		return this.nestedAction;
	}
}
