package gdefalll.gui.actions;

import gdefalll.gui.MyIcons;
import java.awt.Color;
import javax.swing.ImageIcon;

/**
 * End of InternalPlan (subplan) action.
 * This action is in pair with InternalPlanStart action.
 * @see InternalPlan
 * @see InternalPlanStart
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class InternalPlanEnd extends InternalPlan {

	private static final long serialVersionUID = 1L;
	
	public InternalPlanEnd() {
		super();
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.SUBPLAN);
	}

	@Override
	public String getIdentifier() {
		return "@";
	}

	@Override
	String getLabelText() {
		return "Subplan end";
	}

	@Override
	Color getLabelColor() {
		return new Color(128, 0, 255);
	}

	@Override
	public void showEditor() {
	}

	@Override
	public String getALLLCode() {
		return ")";
	}

	@Override
	public void setParameters(String params) {
		// TODO ...
		
	}
}

