package gdefalll.gui.actions;

import java.awt.Color;
import java.awt.Point;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

import gdefalll.events.StringContentListener;
import gdefalll.gui.MyIcons;
import gdefalll.gui.dialogs.MessageOutputEditor;

/**
 * Message output action.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class MessageOutput extends ALLLAction implements StringContentListener{

	private static final long serialVersionUID = 1L;
	/**
	 * Label to show value.
	 */
	JLabel value_label = new JLabel();
	/**
	 * Value of action. "address_number,message_tupple" or "address_number,register_identifier".
	 */
	String value = "1,(abc)"; 

	public MessageOutput() {
		super();		
		value_label.setBackground(this.getBackground());
		value_label.setBounds(getWidth()-130, 0, 130, getHeight());
		showOutputValue();
		add(value_label);
	}
	
	/**
	 * Show internal representation of value.
	 */
	private void showOutputValue()
	{
		value_label.setText(value);
//		String[] tuple = value.split(",");
//		if (tuple.length == 2)
//		{
//			System.out.println(tuple[0] + ";" + tuple[1] + ";" + tuple.length);
//		}
//		else if (tuple.length == 1)
//		{
//			System.out.println(tuple[0] + ";" + tuple.length);
//		}
		
//		try
//		{ 
//			int output = Integer.parseInt(value);
//			value_label.setForeground(new Color(0, 0, 0));
//			value_label.setText("Node: " + output);
//	    } catch( NumberFormatException e )
//	    { 
//	    	value_label.setForeground(new Color(153, 153, 255));
//			value_label.setText("Reg " + value + " value");
//	    }		
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.MESSAGE);
	}

	@Override
	public String getIdentifier() {
		return "!";
	}

	@Override
	String getLabelText() {
		return "Send msg";
	}

	@Override
	Color getLabelColor() {
		return new Color(0, 128, 0);
	}

	@Override
	public void showEditor() {
		Point position = new Point(getLocation()); 
		SwingUtilities.convertPointToScreen(position, this);
		MessageOutputEditor editor = new MessageOutputEditor();
		position.x = position.x - editor.getWidth() / 2 + this.getWidth() / 2;
		position.y = position.y - editor.getHeight() / 2 + this.getHeight() / 2;
		editor.setLocation(position);
		editor.setText(value);
		editor.sg.addListener(this);
		editor.setVisible(true);
	}

	@Override
	public String getALLLCode() {
		return getIdentifier() + "(" + value + ")";	
	}

	@Override
	public void stringContentReceived(String text) {
		value = text;
		showOutputValue();
		this.ACG.fireActionChanged();
	}

	@Override
	public void setParameters(String params) {
		stringContentReceived(params);
	}
}
