package gdefalll.gui.actions;

import gdefalll.gui.MyIcons;

import java.awt.Color;

import javax.swing.ImageIcon;

/**
 * Action to create space in the plan for new action to be added.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class NewAction extends ALLLAction {

	private static final long serialVersionUID = 1L;

	public NewAction() {
		super();
		setBackground(new Color(0, 0, 128));
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.NEW_ACTION);
	}

	@Override
	public String getIdentifier() {
		return "x";
	}

	@Override
	String getLabelText() {
		return "New action";
	}

	@Override
	Color getLabelColor() {
		return new Color(255, 255, 255);
	}

	@Override
	public void showEditor() {

	}
	
	@Override
	public String getALLLCode() {
		return "";
	}

	@Override
	public void setParameters(String params) {
		// No params
	}
}
