package gdefalll.gui.actions;

import java.awt.Color;
import javax.swing.ImageIcon;
import gdefalll.gui.MyIcons;

/**
 * Action that place notifier of incoming message. When WaitMsg is called it check if there was incoming message
 * after we called this marker and skip WaitMsg. Otherwise it wait for next incoming message.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class StartMsgWait extends ALLLAction {

	private static final long serialVersionUID = 1L;
	private static final int label_width = 150;

	public StartMsgWait() {
		super();
		label.setBounds(0, 0, label_width, height);
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.WAIT_MSG_START);
	}

	@Override
	public String getIdentifier() {
		return "a";
	}

	@Override
	String getLabelText() {
		return "Message notice";
	}

	@Override
	Color getLabelColor() {
		return new Color(0, 0, 0);
	}

	@Override
	public void showEditor() {
	}

	@Override
	public String getALLLCode() {
		return "$(" + getIdentifier() + ")";	
	}

	@Override
	public void setParameters(String params) {
		// No params
	}
}
