package gdefalll.gui.actions;

import java.awt.Color;
import javax.swing.ImageIcon;
import gdefalll.gui.MyIcons;

/**
 * Action to wait for incoming message action.
 * @see StartMsgWait
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class WaitMsg extends ALLLAction {

	private static final long serialVersionUID = 1L;

	public WaitMsg() {
		super();
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.WAIT_MSG);
	}

	@Override
	public String getIdentifier() {
		return "s";
	}

	@Override
	String getLabelText() {
		return "Wait for msg";
	}

	@Override
	Color getLabelColor() {
		return new Color(0, 0, 0);
	}

	@Override
	public void showEditor() {
	}

	@Override
	public String getALLLCode() {
		return "$(" + getIdentifier() + ")";	
	}

	@Override
	public void setParameters(String params) {
		// No params
	}
}
