package gdefalll.gui.dialogs;

import gdefalll.events.OkCancelListener;
import gdefalll.events.StringContentGenerator;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.border.EmptyBorder;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * Dialog to edit Agent name.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class AgentNameEditor extends JDialog implements OkCancelListener {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	JTextPane bbEditor = new JTextPane();	
	/**
	 * Output value is generated here. All listener should register here.
	 */
	public StringContentGenerator sg = new StringContentGenerator();

	/**
	 * Create the dialog.
	 */
	public AgentNameEditor() {
		setTitle("Name editor");		
		setModal(true);
		setBounds(100, 100, 404, 170);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new BorderLayout(0, 0));
		{
			contentPanel.add(bbEditor);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleOkEvent();						
					}					
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleCancelEvent();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
			bbEditor.requestFocusInWindow();
		}
	}
	
	public void setText(String text)
	{
		bbEditor.setText(text);
	}
	
	private void clearAndHide() {
		//bbEditor.setText(null);
		//setVisible(false);
		dispose();
	}

	@Override
	public void handleOkEvent() {
		if (bbEditor.isValid())
		{
			sg.fire(bbEditor.getText());
			clearAndHide();
		}
		else
		{
			JOptionPane.showMessageDialog(null, "There are errors in the code!!!");
			bbEditor.requestFocusInWindow();
		}	
	}

	@Override
	public void handleCancelEvent() {
		clearAndHide();
	}
}