package gdefalll.gui.dialogs;

import gdefalll.events.OkCancelListener;
import gdefalll.events.StringContentGenerator;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JLabel;
import java.awt.GridLayout;
import java.awt.Color;

/**
 * Dialog to edit Leds action.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class LedsEditor extends JDialog implements OkCancelListener {

	private static final long serialVersionUID = 1L;
	/**
	 * Output value is generated here. All listener should register here.
	 */
	public StringContentGenerator sg = new StringContentGenerator();
	final ButtonGroup bgroupColor = new ButtonGroup();
	final ButtonGroup bgroupAction = new ButtonGroup();
	/**
	 * First part of Leds.value.
	 * @see Leds.value
	 */
	private String valueColor = "RED";
	/**
	 * Second part of Leds.value.
	 * @see Leds.value
	 */
	private String valueAction = "ON";
	JLabel lblNewLabel = new JLabel("Color");
	JLabel lblNewLabel_1 = new JLabel("Action");
	JLabel lblNewLabel_2 = new JLabel("Substitution");
	JRadioButton rdbtnRed = new JRadioButton("Red");
	JRadioButton rdbtnGreen = new JRadioButton("Green");
	JRadioButton rdbtnYellow = new JRadioButton("Yellow");
	JRadioButton rdbtnOn = new JRadioButton("On");
	JRadioButton rdbtnOff = new JRadioButton("Off");
	JRadioButton rdbtnToggle = new JRadioButton("Toggle");
	JRadioButton rdbtnRegister1 = new JRadioButton("Register 1");
	JRadioButton rdbtnRegister2 = new JRadioButton("Register 2");
	JRadioButton rdbtnRegister3 = new JRadioButton("Register 3");
	final ButtonGroup bgroupRegister = new ButtonGroup();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			WaitTimeEditor dialog = new WaitTimeEditor();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public LedsEditor() {
		setBounds(100, 100, 302, 208);
		{
			JPanel panel = new JPanel();
			getContentPane().add(panel);
			panel.setLayout(new GridLayout(0, 3, 0, 0));
			panel.add(lblNewLabel);
			panel.add(lblNewLabel_1);
			panel.add(lblNewLabel_2);
			rdbtnRed.setForeground(Color.RED);
			panel.add(rdbtnRed);
			panel.add(rdbtnOn);
			panel.add(rdbtnRegister1);
			rdbtnGreen.setForeground(new Color(0, 204, 0));
			panel.add(rdbtnGreen);
			panel.add(rdbtnOff);
			panel.add(rdbtnRegister2);
			rdbtnYellow.setForeground(new Color(255, 153, 51));
			panel.add(rdbtnYellow);
			panel.add(rdbtnToggle);
			panel.add(rdbtnRegister3);
			
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleOkEvent();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleCancelEvent();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		rdbtnRed.setSelected(true);
		rdbtnGreen.setSelected(false);
		rdbtnYellow.setSelected(false);		
		setColorListeners(rdbtnRed);
		setColorListeners(rdbtnGreen);
		setColorListeners(rdbtnYellow);
		rdbtnOn.setSelected(true);
		rdbtnOff.setSelected(false);
		rdbtnToggle.setSelected(false);		
		setActionListeners(rdbtnOn);
		setActionListeners(rdbtnOff);
		setActionListeners(rdbtnToggle);
		rdbtnRegister1.setSelected(false);
		rdbtnRegister2.setSelected(false);
		rdbtnRegister3.setSelected(false);		
		setRegistersListeners(rdbtnRegister1);
		setRegistersListeners(rdbtnRegister2);
		setRegistersListeners(rdbtnRegister3);
	}

	/**
	 * The value to enable proper radiobuttons inside this editor.
	 * @param value
	 */
	public void setText(String value) {
		if (value.equals("RED ON"))
		{
			valueColor = "RED";
			valueAction = " ON";
			rdbtnRed.setSelected(true);
			rdbtnOn.setSelected(true);
		}
		else if (value.equals("RED OFF"))
		{
			valueColor = "RED";
			valueAction = " OFF";
			rdbtnRed.setSelected(true);
			rdbtnOff.setSelected(true);
		}
		else if (value.equals("GREEN ON"))
		{
			valueColor = "GREEN";
			valueAction = " ON";
			rdbtnGreen.setSelected(true);
			rdbtnOn.setSelected(true);
		}
		else if (value.equals("GREEN OFF"))
		{
			valueColor = "GREEN";
			valueAction = " OFF";
			rdbtnGreen.setSelected(true);
			rdbtnOff.setSelected(true);
		}
		else if (value.equals("YELLOW ON"))
		{
			valueColor = "YELLOW";
			valueAction = " ON";
			rdbtnYellow.setSelected(true);
			rdbtnOn.setSelected(true);
		}
		else if (value.equals("YELLOW OFF"))
		{
			valueColor = "YELLOW";
			valueAction = " OFF";
			rdbtnYellow.setSelected(true);
			rdbtnOff.setSelected(true);
		}
		else if (value.equals("RED TOGGLE"))
		{
			valueColor = "RED";
			valueAction = " TOGGLE";
			rdbtnRed.setSelected(true);
			rdbtnToggle.setSelected(true);
		}
		else if (value.equals("GREEN TOGGLE"))
		{
			valueColor = "GREEN";
			valueAction = " TOGGLE";
			rdbtnGreen.setSelected(true);
			rdbtnToggle.setSelected(true);
		}
		else if (value.equals("YELLOW TOGGLE"))
		{
			valueColor = "YELLOW";
			valueAction = " TOGGLE";
			rdbtnYellow.setSelected(true);
			rdbtnToggle.setSelected(true);
		}
		else if (value.equals("&1"))
		{
			valueColor = "&";
			valueAction = "1";
			rdbtnRegister1.setSelected(true);
			bgroupColor.clearSelection();
			bgroupAction.clearSelection();
		}
		else if (value.equals("&2"))
		{
			valueColor = "&";
			valueAction = "2";
			rdbtnRegister2.setSelected(true);
			bgroupColor.clearSelection();
			bgroupAction.clearSelection();
		}
		else if (value.equals("&3"))
		{
			valueColor = "&";
			valueAction = "3";
			rdbtnRegister3.setSelected(true);
			bgroupColor.clearSelection();
			bgroupAction.clearSelection();
		}
	}

	private void clearAndHide() {
		dispose();
	}

	@Override
	public void handleOkEvent() {
		sg.fire(valueColor + valueAction);
		clearAndHide();
	}

	@Override
	public void handleCancelEvent() {
		clearAndHide();
	}

	private void setColorListeners(final JRadioButton btn) {
		bgroupColor.add(btn);
		btn.setFocusPainted(false);
		btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (btn == rdbtnRed)
				{
					valueColor = "RED";
				}
				else if (btn == rdbtnGreen)
				{
					valueColor = "GREEN";
				}
				else if (btn == rdbtnYellow)
				{
					valueColor = "YELLOW";
				}
				if (rdbtnRegister1.isSelected() || rdbtnRegister2.isSelected() || rdbtnRegister3.isSelected())
				{
					bgroupRegister.clearSelection();
					valueAction = " ON";
					rdbtnOn.setSelected(true);
				}				
			}
		});
	}
	
	private void setActionListeners(final JRadioButton btn) {
		bgroupAction.add(btn);
		btn.setFocusPainted(false);
		btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (btn == rdbtnOn)
				{
					valueAction = " ON";
				}
				else if (btn == rdbtnOff)
				{
					valueAction = " OFF";
				}
				else if (btn == rdbtnToggle)
				{
					valueAction = " TOGGLE";
				}
				if (rdbtnRegister1.isSelected() || rdbtnRegister2.isSelected() || rdbtnRegister3.isSelected())
				{
					bgroupRegister.clearSelection();
					valueColor = "RED";
					rdbtnRed.setSelected(true);
				}		
			}
		});
	}
	
	private void setRegistersListeners(final JRadioButton btn) {
		bgroupRegister.add(btn);
		btn.setFocusPainted(false);
		btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (btn == rdbtnRegister1)
				{
					valueColor = "&";
					valueAction = "1";
				}
				else if (btn == rdbtnRegister2)
				{
					valueColor = "&";
					valueAction = "2";
				}
				else if (btn == rdbtnRegister3)
				{
					valueColor = "&";
					valueAction = "3";
				}
				bgroupColor.clearSelection();
				bgroupAction.clearSelection();
			}
		});
	}
	
	

}
