package gdefalll.gui.dialogs;

import gdefalll.events.OkCancelListener;
import gdefalll.events.StringContentGenerator;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.BoxLayout;
import javax.swing.JRadioButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.SpinnerNumberModel;

/**
 * Dialog to edit MessageOutput action.
 * @see MessageOuput
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class MessageOutputEditor extends JDialog implements OkCancelListener {

	private static final long serialVersionUID = 1L;
	/**
	 * Output value is generated here. All listener should register here.
	 */
	public StringContentGenerator sg = new StringContentGenerator();
	JRadioButton rdbtnRegister1 = new JRadioButton("Register 1");
	JRadioButton rdbtnRegister2 = new JRadioButton("Register 2");
	JRadioButton rdbtnRegister3 = new JRadioButton("Register 3");
	JRadioButton rdbtnDestination = new JRadioButton("Destination:");
	JRadioButton rdbtnDestinationReg = new JRadioButton("Destination:");
	final ButtonGroup bgroup = new ButtonGroup();
	JRadioButton rdbtnMsgRegister1 = new JRadioButton("Register 1");
	JRadioButton rdbtnMsgRegister2 = new JRadioButton("Register 2");
	JRadioButton rdbtnMsgRegister3 = new JRadioButton("Register 3");
	final ButtonGroup bgroupOpt2 = new ButtonGroup();
	/**
	 * @see MessageOuput.value
	 */
	private String value = "1,(abc)";
	private JTextField messageOpt1 = new JTextField();
	JSpinner addressOpt1 = new JSpinner();
	JSpinner addressOpt2 = new JSpinner();


	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			WaitTimeEditor dialog = new WaitTimeEditor();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public MessageOutputEditor() {
		setBounds(100, 100, 381, 332);
		{
			JPanel panel = new JPanel();
			getContentPane().add(panel);
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{
					panel_1.add(rdbtnDestination);
				}
				{
					
					addressOpt1.setModel(new SpinnerNumberModel(new Integer(1),
							new Integer(1), null, new Integer(1)));
					addressOpt1.setPreferredSize(new Dimension(50, 20));
					panel_1.add(addressOpt1);
				}
				{
					JLabel lblMessage = new JLabel("Message:");
					panel_1.add(lblMessage);
				}
				{
					
					messageOpt1.setText("abc");
					panel_1.add(messageOpt1);
					messageOpt1.setColumns(10);
				}
			}
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new BorderLayout(0, 0));
				{
					JPanel panel_2 = new JPanel();
					panel_1.add(panel_2, BorderLayout.WEST);
					{
						panel_2.add(rdbtnDestinationReg);
					}
					{
						
						addressOpt2.setModel(new SpinnerNumberModel(new Integer(1),
								new Integer(1), null, new Integer(1)));
						addressOpt2.setPreferredSize(new Dimension(50, 20));
						panel_2.add(addressOpt2);
					}
				}
				{
					JPanel panel_2 = new JPanel();
					panel_1.add(panel_2);
					panel_2.setLayout(new BoxLayout(panel_2, BoxLayout.Y_AXIS));
					{
						JLabel lblMessage_1 = new JLabel("Message:");
						panel_2.add(lblMessage_1);
					}
					{
						panel_2.add(rdbtnMsgRegister1);
					}
					{
						panel_2.add(rdbtnMsgRegister2);
					}
					{
						panel_2.add(rdbtnMsgRegister3);
					}
				}
			}
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{

					panel_1.add(rdbtnRegister1);
				}
			}
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{

					panel_1.add(rdbtnRegister2);
				}
			}
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{

					panel_1.add(rdbtnRegister3);
				}
			}
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleOkEvent();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleCancelEvent();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		rdbtnDestination.setSelected(true);
		rdbtnDestinationReg.setSelected(false);
		rdbtnRegister1.setSelected(false);
		rdbtnRegister2.setSelected(false);
		rdbtnRegister3.setSelected(false);
		setButtonsListeners(rdbtnDestination);
		setButtonsListeners(rdbtnDestinationReg);
		setButtonsListeners(rdbtnRegister1);
		setButtonsListeners(rdbtnRegister2);
		setButtonsListeners(rdbtnRegister3);
		setOpt2RegistersListeners(rdbtnMsgRegister1);
		setOpt2RegistersListeners(rdbtnMsgRegister2);
		setOpt2RegistersListeners(rdbtnMsgRegister3);
		setOption2Enabled(false);
	}

	/**
	 * Set the value to be shown inside dialog options.
	 * @param value
	 */
	public void setText(String value) {
		this.value = value;
		if (value.equals("&1"))
		{
			setOption1Enabled(false);
			setOption2Enabled(false);
			rdbtnRegister1.setSelected(true);
		}
		else if (value.equals("&2"))
		{
			setOption1Enabled(false);
			setOption2Enabled(false);
			rdbtnRegister2.setSelected(true);
		}
		else if (value.equals("&3"))
		{
			setOption1Enabled(false);
			setOption2Enabled(false);
			rdbtnRegister3.setSelected(true);
		}
		else
		{
			String[] tuple = value.split(",");
			int address = 1;
			try {
				address = Integer.parseInt(tuple[0]);
			} catch (NumberFormatException e) {
			}
			if (tuple[1].equals("&1"))
			{
				setOption1Enabled(false);
				setOption2Enabled(true);
				rdbtnDestinationReg.setSelected(true);
				rdbtnMsgRegister1.setSelected(true);
				addressOpt2.setValue(address);
			}
			else if (tuple[1].equals("&2"))
			{
				setOption1Enabled(false);
				setOption2Enabled(true);
				rdbtnDestinationReg.setSelected(true);
				rdbtnMsgRegister2.setSelected(true);
				addressOpt2.setValue(address);
			}
			else if (tuple[1].equals("&3"))
			{
				setOption1Enabled(false);
				setOption2Enabled(true);
				rdbtnDestinationReg.setSelected(true);
				rdbtnMsgRegister3.setSelected(true);
				addressOpt2.setValue(address);
			}
			else
			{
				setOption1Enabled(true);
				setOption2Enabled(false);
				rdbtnDestination.setSelected(true);
				addressOpt1.setValue(address);
				messageOpt1.setText(tuple[1]);
			}
		}
//		try {
//			int output = Integer.parseInt(value);
//			ValueBox.setText(value);
//			rdbtnTimeInMs.setSelected(true);
//			ValueBox.setEnabled(true);
//			ValueBox.requestFocusInWindow();
//		} catch (NumberFormatException e) {
//			if (value.equals("&1")) {
//				ValueBox.setEnabled(false);
//				rdbtnRegister1.setSelected(true);
//			} else if (value.equals("&2")) {
//				ValueBox.setEnabled(false);
//				rdbtnRegister2.setSelected(true);
//			} else if (value.equals("&3")) {
//				ValueBox.setEnabled(false);
//				rdbtnRegister3.setSelected(true);
//			}
//		}
	}

	private void clearAndHide() {
		dispose();
	}

	@Override
	public void handleOkEvent() {
//		if (ValueBox.isEnabled()) {
//			value = ValueBox.getText();
//		}
		if (rdbtnRegister1.isSelected())
		{
			value = "&1";
		}
		else if (rdbtnRegister2.isSelected())
		{
			value = "&2";
		}
		else if (rdbtnRegister3.isSelected())
		{
			value = "&3";
		}
		else if (rdbtnDestination.isSelected())
		{
			value = addressOpt1.getValue().toString() + "," + messageOpt1.getText();
		}
		else if (rdbtnDestinationReg.isSelected())
		{
			value = addressOpt2.getValue().toString() + ",";
			if (rdbtnMsgRegister1.isSelected())
			{
				value += "&1";
			}
			else if (rdbtnMsgRegister2.isSelected())
			{
				value += "&2";
			}
			else if (rdbtnMsgRegister3.isSelected())
			{
				value += "&3";
			}
		}
		sg.fire(value);
		clearAndHide();
	}

	@Override
	public void handleCancelEvent() {
		clearAndHide();
	}
	
	private void setOption1Enabled(boolean flag)
	{
		if (flag)
		{
			addressOpt1.setEnabled(true);
			messageOpt1.setEnabled(true);
		}
		else
		{
			addressOpt1.setEnabled(false);
			messageOpt1.setEnabled(false);
		}
	}
	
	private void setOption2Enabled(boolean flag)
	{
		if (flag)
		{
			addressOpt2.setEnabled(true);
			rdbtnMsgRegister1.setSelected(true);
		}
		else
		{
			addressOpt2.setEnabled(false);
			bgroupOpt2.clearSelection();
		}
	}

	private void setButtonsListeners(final JRadioButton btn) {
		bgroup.add(btn);
		btn.setFocusPainted(false);
		btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (btn == rdbtnRegister1)
				{
					setOption1Enabled(false);
					setOption2Enabled(false);
				}
				else if (btn == rdbtnRegister2)
				{
					setOption1Enabled(false);
					setOption2Enabled(false);
				}
				else if (btn == rdbtnRegister3)
				{
					setOption1Enabled(false);
					setOption2Enabled(false);
				}
				else if (btn == rdbtnDestination)
				{
					setOption1Enabled(true);
					setOption2Enabled(false);
				}
				else if (btn == rdbtnDestinationReg)
				{
					setOption1Enabled(false);
					setOption2Enabled(true);
				}
			}
		});
	}
	
	private void setOpt2RegistersListeners(final JRadioButton btn) {
		bgroupOpt2.add(btn);
		btn.setFocusPainted(false);
	}

}
