package gdefalll.gui.dialogs;

import gdefalll.events.OkCancelListener;
import gdefalll.events.StringContentGenerator;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Vector;

/**
 * Dialog for RemotePlan selection.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class RemotePlanEditor extends JDialog implements OkCancelListener {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	/**
	 * Output value is generated here. All listener should register here.
	 */
	public StringContentGenerator sg = new StringContentGenerator();
	JComboBox comboBox = new JComboBox();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Vector<String> plans = new Vector<String>();
			RemotePlanEditor dialog = new RemotePlanEditor(plans);
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public RemotePlanEditor(Vector<String> plans) {
		setBounds(100, 100, 246, 102);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setLayout(new FlowLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.EAST);
		{
			JLabel lblRemotePlanName = new JLabel("Remote plan name:");
			contentPanel.add(lblRemotePlanName);
		}
		{
			comboBox.setModel(new DefaultComboBoxModel(plans));
			contentPanel.add(comboBox);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleOkEvent();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						handleCancelEvent();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}
	
	private void clearAndHide() {
		dispose();
	}

	@Override
	public void handleOkEvent() {
		Object selectedItem = comboBox.getSelectedItem();
		if (selectedItem != null)
		{
			sg.fire(comboBox.getSelectedItem().toString());
		}
		else
		{
			sg.fire("null");
		}
		clearAndHide();
	}

	@Override
	public void handleCancelEvent() {
		clearAndHide();
	}

}
