package gdefalll.gui.dialogs;

import gdefalll.events.OkCancelListener;
import gdefalll.events.StringContentGenerator;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.BoxLayout;
import javax.swing.JFormattedTextField;
import javax.swing.JRadioButton;


import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;


import java.awt.event.KeyEvent;

/**
 * Dialog to edit WaitTime action.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class WaitTimeEditor extends JDialog implements OkCancelListener{

	private static final long serialVersionUID = 1L;
	/**
	 * Output value is generated here. All listener should register here.
	 */
	public StringContentGenerator sg = new StringContentGenerator();
	JFormattedTextField ValueBox;
	
	JRadioButton rdbtnTimeInMs = new JRadioButton("Time in ms:");
	JRadioButton rdbtnRegister1 = new JRadioButton("Register 1");
	JRadioButton rdbtnRegister2 = new JRadioButton("Register 2");
	JRadioButton rdbtnRegister3 = new JRadioButton("Register 3");
	final ButtonGroup bgroup = new ButtonGroup();
	private String value = "1000";

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			WaitTimeEditor dialog = new WaitTimeEditor();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	

	/**
	 * Create the dialog.
	 */
	public WaitTimeEditor() {
		ValueBox = new JFormattedTextField();
		ValueBox.addKeyListener(new KeyAdapter() {
			   public void keyTyped(KeyEvent e) {
			      char c = e.getKeyChar();
			      if ( ((c < '0') || (c > '9')) && (c != KeyEvent.VK_BACK_SPACE) && (c != KeyEvent.VK_DELETE)){
			         e.consume();  // ignore event
			      }
			   }
			});
		setBounds(100, 100, 266, 209);
		{
			JPanel panel = new JPanel();
			getContentPane().add(panel);
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{
					panel_1.add(rdbtnTimeInMs);
				}
				{
					ValueBox.setPreferredSize(new Dimension(50, 20));
					
					ValueBox.setText("1000");
					panel_1.add(ValueBox);
				}
			}
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{
					
					panel_1.add(rdbtnRegister1);
				}
			}
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{
					
					panel_1.add(rdbtnRegister2);
				}
			}
			{
				JPanel panel_1 = new JPanel();
				panel.add(panel_1);
				panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
				{
					
					panel_1.add(rdbtnRegister3);
				}
			}
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleOkEvent();						
					}					
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						handleCancelEvent();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		rdbtnTimeInMs.setSelected(true);
		rdbtnRegister1.setSelected(false);
		rdbtnRegister2.setSelected(false);
		rdbtnRegister3.setSelected(false);
		setButtonsListeners(rdbtnTimeInMs);
		setButtonsListeners(rdbtnRegister1);
		setButtonsListeners(rdbtnRegister2);
		setButtonsListeners(rdbtnRegister3);
	}
	
	/**
	 * Set value inside this dialog options.
	 * @param value
	 */
	public void setText(String value)
	{
		this.value = value;
		try
		{ 
			Integer.parseInt(value); //check if it is possible to parse integer
			ValueBox.setText(value);
			rdbtnTimeInMs.setSelected(true);
			ValueBox.setEnabled(true);
			ValueBox.requestFocusInWindow();
	    } catch( NumberFormatException e )
	    { 
	    	if (value.equals("&1"))
	    	{
	    		ValueBox.setEnabled(false);
	    		rdbtnRegister1.setSelected(true);
	    	}
	    	else if (value.equals("&2"))
	    	{
	    		ValueBox.setEnabled(false);
	    		rdbtnRegister2.setSelected(true);
	    	}
	    	else if (value.equals("&3"))
	    	{
	    		ValueBox.setEnabled(false);
	    		rdbtnRegister3.setSelected(true);
	    	}
	    }	
	}
	
	private void clearAndHide() {
		dispose();
	}
	
	@Override
	public void handleOkEvent() {
		if (ValueBox.isEnabled())
		{
			value = ValueBox.getText();
		}
		sg.fire(value);
		clearAndHide();
	}

	@Override
	public void handleCancelEvent() {
		clearAndHide();
	}
	
	/**
	 * Register handlers of radiobuttons.
	 * @param btn
	 */
	private void setButtonsListeners(final JRadioButton btn)
	{
		bgroup.add(btn);
		btn.setFocusPainted(false);
		btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (btn == rdbtnTimeInMs)
				{
					ValueBox.setEnabled(true);
				}
				else if (btn == rdbtnRegister1)
				{
					ValueBox.setEnabled(false);
					value = "&1";
				}
				else if (btn == rdbtnRegister2)
				{
					ValueBox.setEnabled(false);
					value = "&2";
				}
				else if (btn == rdbtnRegister3)
				{
					ValueBox.setEnabled(false);
					value = "&3";
				}
			}
		});
	}

}
